; File: RMCBTEST.ASM

; Author: Matthew Mastracci

; Purpose: Implements the real-mode callback mouse driver

[BITS 32]

%include "general.inc"

[GLOBAL _MouseCallback]
[GLOBAL _MouseX]
[GLOBAL _MouseY]
[GLOBAL _MouseButtons]

[SECTION .text ALIGN=4]

; ---------------------------------------------------------------------------
; Prototype: void MouseCallback(__dpmi_regs * r)
; Returns: nothing
; ---------------------------------------------------------------------------
Pointer_MouseCallback   equ 8        

align
_MouseCallback:
        push ebp
        mov ebp, esp

        mov esi, [ebp + Pointer_MouseCallback]
        
        xor eax, eax
        mov ax, [esi + 16]     ; offset of bx in __dpmi_regs
        mov [_MouseButtons], eax
        mov ax, [esi + 24]     ; offset of cx in __dpmi_regs
        mov [_MouseX], eax
        mov ax, [esi + 20]     ; offset of dx in __dpmi_regs
        mov [_MouseY], eax

        mov esp, ebp
        pop ebp
        ret

[SECTION .data ALIGN=4]

_MouseX         dd 00000000h
_MouseY         dd 00000000h
_MouseButtons   dd 00000000h
